#include "stdafx.h"
#include "cphidgetgyroscope.h"
#include "math.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CMAKEPACKET_BUF(Gyroscope, outputPacket, outputPacketLen)

CFHANDLE(Gyroscope,AngularRate) int, double), void *userPtr)
ASGNFPTR(Gyroscope,AngularRate)

CPHIDGETDATA(Gyroscope)
	int i;
	double dx,dy,dz;

	TESTPTR(phid)
	
	switch(phid->phid.deviceIDSpec)
	{
		case PHIDSPEC_GYRO_with_ACCELEROMETER:
			if (phid->phid.deviceVersion < 200)
			{
				i = ((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				dx = (((double)(i-32768)) / 196.605);
				i = ((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				dy = (((double)(i-32768)) / 196.605);
				i = ((unsigned short)buffer[4]+((unsigned short)buffer[5]<<8));
				dz = (((double)(i-32768)) / 196.605);
			}
			break;
		default:
			break;
	}

	phid->axis[0] = dx;
	phid->axis[1] = dy;
	phid->axis[2] = dz;

	if (fabs(dx - phid->axisLastTrigger[0]) > phid->axisChangeTrigger[0])
	{
		FIRE(AngularRate) 0, dx);
		phid->axisLastTrigger[0] = dx;
	}
	if (fabs(dy - phid->axisLastTrigger[1]) > phid->axisChangeTrigger[1])
	{
		FIRE(AngularRate) 1, dy);
		phid->axisLastTrigger[1] = dy;
	}
	if (fabs(dz - phid->axisLastTrigger[2]) > phid->axisChangeTrigger[2])
	{
		FIRE(AngularRate) 2, dz);
		phid->axisLastTrigger[2] = dz;
	}

	return EPHIDGET_OK;

}

CSETINDEX(Gyroscope,AngularRateChangeTrigger,double)
	TESTPTR(phid) 
	TESTRNG1(phid.attr.gyroscope.numAxis)
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Trigger, "%lf")
	else
		phid->axisChangeTrigger[Index] = newVal;
	return EPHIDGET_OK;
}

CGETINDEX(Gyroscope,AngularRate,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.gyroscope.numAxis)
	MASGN(axis[Index]);
}

CGETINDEX(Gyroscope,AngularRateChangeTrigger,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.gyroscope.numAxis)
	MASGN(axisChangeTrigger[Index])
}

CGET(Gyroscope,NumAxis,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.gyroscope.numAxis)
}

CPHIDGETINIT(Gyroscope)
	phid = 0;
	return EPHIDGET_OK;
}

CCREATE(Gyroscope, PHIDDEF_GYROSCOPE)
