/*
  Name : hqi.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a hqi lamp
*/

#ifndef _HQI_HPP_
#define _HQI_HPP_

#include "lampes.hpp"


class HQI: public Lampes
{
private:
  bool started; //used to start the HQI after X minutes

 
    
  void stopper (K8055 &,config &);	//stop the HQI
  void noStart();	//do not start the HQI if the temperature is too high
  void start();	//start the HQI
  
  void forceState(short forcedState,K8055 &k,config &cfg);//force the state
  void changeState (short state,K8055 &k,config &cfg);	//change the state of the module of the 3rd argument 
   
public:
  time_t timer; 
 
  HQI(){init();}
  void init();	//initialize the blue lamp
  
  short getStarted();
 
  void setStarted (bool);
   
  void changing (short ,double,K8055&,config &);//define the state witch the lamp had to be
};

#endif
