/*
  Name : phsonde.hpp
  Copyright : sebastien salva
  Authors : sebastien salva
  Description: file which contents functions to use lamps
*/

#ifndef _PH_HPP_
#define _PH_HPP_

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "phidget21.h"
#include <signal.h>
#include <sstream>

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "carte.hpp"

class phsonde
{

private:

CPhidgetPHSensorHandle ifkit; 
int n;
double ph;
bool error_ph;
bool first_error;
double correction;
bool ph_usb;
void calibrez(connexion &, K8055 &);
short out;
short card;
string nb;

public:
phsonde(short o, short c,string n){out=o;card=c;nb=n;init();}
void init();
double read_ph(connexion &, K8055 &);
double get_ph();
bool get_error();
void set_first_error(bool);
bool get_first_error();
double get_correction();
void set_correction(double);
~phsonde();
};


#endif
