#include "includes/message.h"

#include <sstream> 
#include "includes/destinataire.h"
#include "includes/prestataire.h"
#include "includes/sock.h"

Message::Message(Prestataire *prest,string message) {
	
	string requeteHTTP = "";
	string enteteHTTP = "";
	
	/*On cree le destiataire*/
	dest = new Destinataire();
	
	/*On recupere les infos destinataire dans la base*/
	dest->recupererInfo();
	
	this->prest = prest;
	
	setMessage(message);
}

string Message::getMessage() {
	return message;
}
void Message::setMessage(string message) {
	this->message = message;
}

string Message::getRequeteHTTP() {
	return requeteHTTP;
}

//Formate l'entete de la requete HTTP
string Message::construireEnteteHTTP(int querySize) {
	
	string enteteHTTP = METHOD + (string) " " + prest->getScript() + " HTTP/1.1\r\n"; 
	enteteHTTP += "Host: " + prest->getHote() + "\r\n";
	enteteHTTP += "Content-Type: application/x-www-form-urlencoded\r\n";
	enteteHTTP += "Content-Length: " + intToString(querySize) + (string) "\r\n";
	enteteHTTP += "Connection: close\r\n\r\n";
	return enteteHTTP;
}

void Message::envoyer(void) {

	string requete = construireEnteteHTTP(requeteHTTP.size()) + getRequeteHTTP(); //On cree la requete
	cout<<requete<<endl;
	
	/*On creer la socket*/
	Sock socket = Sock(prest->getHote(),80);
	socket.connection();
	
	/*On envoi la requete*/
	socket.sendMsg(requete);
	
	}


	



/********************************************************************************/

//Converti un entier en string
string intToString(int value) {
	std::ostringstream oss ;
    oss << value ;
    return oss.str() ;
}

//traduit les caracteres non autorisé pr les parametre de resuete en hexa
string hexEncode(const unsigned char& c)
  {
    string result("%");
    unsigned char v[2]= { c/16, c%16 };
    if (v[0] <= 9) result+= (v[0] + '0');
    else result+= (v[0] - 10 + 'A');
    if (v[1] <= 9) result+= (v[1] + '0');
    else result+= (v[1] - 10 + 'A');
    return result;
  }

//Fct urlEncode (cf php par exemple)
string urlEncode(const string& s) {
    string result;
    unsigned char c;
    for (unsigned int p= 0; p < s.size(); ++p) {
      c= s[p];
	
      if ((c <= 31) || (c >= 127))  // CTL, >127
        result+= hexEncode(c);
      else switch (c) {
      case ';':
      case '/':
      case '?':
      case ':':
      case '@':
      case '&':
      case '=':
      case '+':  // until here: reserved
      case '"':
      case '#':
      case '%':
      case '<':
      case '>':  // until here: unsafe
        result+= hexEncode(c);
        break;
      case ' ':  // SP
        result+= '+';
        break;
      default:  // no need to encode
        result+= c;
        break;
      }
    }
    return result;
  }
