#include "includes/phsonde.hpp"

void phsonde::init() {
int status;

n=0;
ph=0.0;
error_ph=false;
first_error=true;
correction=0;
CPhidgetPHSensor_create(&ifkit); 
CPhidget_open((CPhidget*)ifkit, -1);
CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
if (status==0) 
	{
	ph_usb=false; if (DEBUG == 1) cout << "ph" << nb << " usb: non" <<  endl;
	}
	else ph_usb=true;

//CPhidget_waitForAttachment ((CPhidget*)ifkit, 1000);
//CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
//cout << status<< endl;

    }



double phsonde::read_ph(connexion &c, K8055 &k)
                {
int status;

if (n == 0) {
	if (ph_usb==true)
	{

	               CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
			if (status ==0) 
              		   {error_ph=true;ph=-1;
			   if (first_error==true) {c.insert_log("erreur lecture ph"+nb);send_mail("erreur lecture PH"+nb+" , sonde pas activée !!!",c);first_error=false;}
			}
        		else {    
				calibrez(c,k);
				error_ph=false;
        			first_error=true;
				CPhidgetPHSensor_getPH(ifkit,&ph);
				ph=ph+correction;
				if (DEBUG == 1) cout << "ph usb: " << ph << "calibration: " << correction <<  endl;
				c.insert_current_ph(ph,nb);
			     }	                     
	}
	else //ph_usb=false carte analogic 2
	{
	calibrez(c,k);
	error_ph=false;
	first_error=true;
	ph=(k.readAnalog(out,card)*14.0)/255.0+correction;
	if (DEBUG == 1) cout << "ph" << nb << " analogique+calib: " << ph << "calibration: " << correction <<  endl;
	c.insert_current_ph(ph,nb);	
	}



}     
n++;
if (n==25) n=0;
return ph;   
         }
// calibrer sonde
void phsonde::calibrez(connexion &c, K8055 &k)
    {
        double lecture=0;
        double p=0;

        p = c.calibre_ph(nb);
        if (p!=0)
        {
	       if (DEBUG == 1) cout << "calibrage ph" << nb << endl;
	       if (ph_usb==true) CPhidgetPHSensor_getPH(ifkit,&lecture);
	       else lecture=(14.0*k.readAnalog(out,card))/255.0;
               correction=p-lecture;
      	       c.set_calibre(correction,nb);
	}		            
}

double phsonde::get_ph() {
                    
                    return ph;
                
                }

bool phsonde::get_error() {return error_ph;}
void phsonde::set_first_error(bool b) {first_error=b;}
bool phsonde::get_first_error(){return first_error;}
void phsonde::set_correction(double d) {correction=d;}
double phsonde::get_correction() {return correction;}

phsonde:: ~phsonde()
{
CPhidget_close ((CPhidget*)ifkit);
}
