#include "includes/temperature.hpp"

void Temperature::init()
{
  state=0;
  state_sauv=0;
}

void Temperature::forceState(short forcedState,K8055 &k,config &cfg)
{
  if (state!=forcedState)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(cfg.OUTTEMP,cfg.OUTTEMP_CARD,state,"chauffage forc");
    }
}

void Temperature::stopper (K8055&k,config&cfg)
{
  state=0;
  state_sauv=state;
  k.change_state(cfg.OUTTEMP,cfg.OUTTEMP_CARD,state,"chauffage");
}

void Temperature::start (K8055&k,config&cfg)
{
  state=1;
  state_sauv=state;
  k.change_state(cfg.OUTTEMP,cfg.OUTTEMP_CARD,state,"chauffage");
}



void Temperature::tempState(connexion &c,double temperature,K8055&k,config &cfg)
{
//if the heating's state is forced  
  if(cfg.forced_temp!=0)
    forceState(cfg.forced_temp-1,k,cfg);
  
  else
    {
//set the state to the previous state    
      if (state!=state_sauv)
      {
      	state=state_sauv;
  	k.change_state(cfg.OUTTEMP,cfg.OUTTEMP_CARD,state,"chauffage");
     }
//if the temp is higher than 27C and the heating is running        
      if (temperature > 27 && state==1) 
	stopper (k,cfg);
//if the temp is lower than 25C and the heating is stopped        
      if (temperature < 25.0 && state==0) 
	start(k,cfg);
    }
  
}
